###################################################
### chunk number 1: compile eval=FALSE
###################################################
## #line 69 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
## setwd("~/RegularBayes/Workspace/spikeSlabGAM/pkg/inst/doc/")
## Sweave("UsingSpikeSlabGAM.Rnw")
## tools:::texi2dvi("UsingSpikeSlabGAM.tex", pdf=TRUE, clean=TRUE, quiet=FALSE)
## 


###################################################
### chunk number 2: setup
###################################################
#line 77 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
options(prompt = "R> ", continue = "+  ", width = 70, useFancyQuotes = FALSE, digits=5)
clrs <- c("#E41A1C", "#377EB8", "#4DAF4A", "#984EA3", "#FF7F00", "#FFFF33", 
        "#A65628", "#F781BF", "#999999")


###################################################
### chunk number 3: loadLibs
###################################################
#line 82 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
library("spikeSlabGAM")
library("mboost")


###################################################
### chunk number 4: mkData
###################################################
#line 799 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
set.seed(1312424)
n <- 200
snr <- 3

sm1 <- runif(n)
fsm1 <- dbeta(sm1, 7, 3)/2

sm2 <- runif(n, 0, 1)
f <- gl(3, n/3)
ff <- as.numeric(f)/2
fsm2f <- ff + ff*sm2 + 
        ((f==1)*-dbeta(sm2, 6, 4) + (f==2)*dbeta(sm2, 6, 9) + (f==3)*dbeta(sm2, 9, 6))/2

lin <- matrix(rnorm(n*3),n,3) 
colnames(lin) <- paste("lin",1:3, sep="")

noise1 <- sm1 + rnorm(n)
noise2 <- runif(n)
noise3 <- runif(n)
noise4 <- sample(gl(4, n/4))

eta <- fsm1 + fsm2f + lin%*%c(.1, .2, .3) 
y <- eta + sd(eta)/snr * rt(n, df = 5)
d <- data.frame(y, sm1, sm2, f, lin, noise1, noise2, noise3, noise4)


###################################################
### chunk number 5: defForm1
###################################################
#line 827 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
f1 <- y ~ (sm1 + sm2 + f + lin1)^2 + lin2 +lin3 + noise1 + noise2 + noise3 + noise4


###################################################
### chunk number 6: fit1
###################################################
#line 831 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
m <- spikeSlabGAM(formula=f1, data=d)


###################################################
### chunk number 7: summary1.1Fake eval=FALSE
###################################################
## #line 845 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
## summary(m)


###################################################
### chunk number 8: summary1.1Prep
###################################################
#line 849 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
sum <- summary(m)


###################################################
### chunk number 9: summary1.1
###################################################
#line 852 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
print(sum, printModels=F)


###################################################
### chunk number 10: summary1.2
###################################################
#line 858 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
#this is just ctrl-c-v from summary.spikeSlabGAM s.t. we don't get too much redundant 
# info about model formula etc. 
# roughly the same as: print(sum, printPGamma=F, printModels=T) 
cat("\nPosterior model probabilities (inclusion threshold =",sum$thresh,"):\n")
modelTable <- {
    #make ("x","")-vectors out of model names
    models <- sapply(names(sum$modelTable), function(x){
                sapply(strsplit(gsub("1", "x", x),""),
                        function(y) gsub("0", "", y))
            })
    models <- rbind(round(sum$modelTable,3), models, round(cumsum(sum$modelTable), 3))
    rownames(models) <- c("prob.:", names(sum$predvars[!grepl("u(", names(sum$predvars), fixed=TRUE)]), "cumulative:")
    models <- data.frame(models)
    showModels <- 8
    models <- models[,1:showModels, drop=F]
    colnames(models) <- 1:NCOL(models)
    models
}   
print(modelTable)


###################################################
### chunk number 11: plotm1Fake eval=FALSE
###################################################
## #line 917 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
## plot(m)


###################################################
### chunk number 12: plotm1Prep
###################################################
#line 920 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
#tweak legend size:
p1 <- plot(m, maxPlotsPerPage=12, ggElems=list(opts(legend.key.size = unit(0.01, "npc"),  legend.text = theme_text(size = 7),
                        legend.title=theme_text(size=8, hjust = 0), axis.text.x = theme_text(size=8),
						axis.text.y = theme_text(size=8, hjust=1),
						plot.margin=unit(c(0.5, 0, 0, 0), "lines"))))
# # replace expression(eta) with latex for tikz-rendering: (JSS-version only)
#scGr <- scale_colour_gradient2(name="$\\eta$", low =  muted('darkblue'), mid = 'grey80', high = muted('darkred'))
#p1[[2]] <- p1[[2]] + scGr
#p1[[4]] <- p1[[4]] + scGr
#p1[[6]] <- p1[[6]] + scGr
#for(i in (1:12)[-c(2,4,6)]) p1[[i]] <- p1[[i]] + ylab("$\\eta$")


###################################################
### chunk number 13: plotm1
###################################################
#line 934 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
arrangeHere <- function(...) arrange.ggplots(..., rows=as.list(rep(1:4,3)), cols=as.list(rep(1:3, e=4)))
do.call(arrangeHere, p1)


###################################################
### chunk number 14: plotm1sm1Fake eval=FALSE
###################################################
## #line 961 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
## plot(m, labels=c("lin(sm1)", "sm(sm1)"), cumulative=FALSE)
## trueFsm1 <-data.frame(truth=fsm1-mean(fsm1), sm1=sm1)
## plot(m, labels="sm(sm1)", ggElems=list(geom_line(aes(x=sm1, y=truth), data=trueFsm1, linetype=2)))


###################################################
### chunk number 15: plotm1sm1Prep
###################################################
#line 966 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
pSm11 <- plot(m, labels="sm(sm1)", ggElems=list(opts(axis.text.x = theme_text(size=9),
				axis.text.y = theme_text(size=9, hjust=1))))
pSm1Sep <-  plot(m, labels=c("lin(sm1)", "sm(sm1)"), cumulative=FALSE, ggElems=list(opts(axis.text.x = theme_text(size=9),
						axis.text.y = theme_text(size=9, hjust=1))), rows=list(1,1), cols=list(1,2)) #, 
# JSS version only:        ggElems=list(list(ylab("$\\eta$"))))


###################################################
### chunk number 16: plotm1sm1
###################################################
#line 973 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
trueFsm1 <-data.frame(truth=fsm1-mean(fsm1), sm1=sm1)
pSm1Cum <- pSm11[[1]] + geom_line(data=trueFsm1, aes(x=sm1, y=truth), lty=2)  + opts(axis.text.x = theme_text(size=9),
		axis.text.y = theme_text(size=9, hjust=1))# + ylab("$\\eta$")
arrange.ggplots(pSm1Sep[[1]], pSm1Sep[[2]], pSm1Cum)


###################################################
### chunk number 17: plotm1sm2fFake eval=FALSE
###################################################
## #line 988 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
## trueFsm2f <-data.frame(truth=fsm2f-mean(fsm2f), sm2=sm2, f=f)
## plot(m, labels="sm(sm2):fct(f)", ggElems=list(geom_line(aes(x=sm2, y=truth, colour=f), data=trueFsm2f, linetype=2)))


###################################################
### chunk number 18: plotm1sm2f
###################################################
#line 992 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
trueFsm2f <-data.frame(truth=fsm2f-mean(fsm2f), sm2=sm2, f=f)
#JSS only: plot(m, labels="sm(sm2):fct(f)", ggElems=list(list(ylab("$\\eta$")), geom_line(aes(x=sm2, y=truth, colour=f), data=trueFsm2f, linetype=2)))
plot(m, labels="sm(sm2):fct(f)", ggElems=list(geom_line(aes(x=sm2, y=truth, colour=f), data=trueFsm2f, linetype=2)))


###################################################
### chunk number 19: pimaDataPrep
###################################################
#line 1018 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
data("PimaIndiansDiabetes2", package = "mlbench")
pimaDiab <- na.omit(PimaIndiansDiabetes2[, -c(4, 5)])
pimaDiab <- within(pimaDiab,{
            diabetes <- 1*(diabetes=="pos")
        })
set.seed(1109712439)
testInd <- sample(1:nrow(pimaDiab), 200)
pimaDiabTrain <- pimaDiab[-testInd,]  


###################################################
### chunk number 20: pimaM0
###################################################
#line 1033 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
mcmc <- list(nChains=8, chainLength=1000, burnin=500, thin=5)
m0 <- spikeSlabGAM(diabetes ~ pregnant + glucose + pressure + mass + pedigree + age,
        family="binomial", data=pimaDiabTrain, mcmc=mcmc)


###################################################
### chunk number 21: pimaM0Summary
###################################################
#line 1039 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
pr0 <- predict(m0, newdata=pimaDiab[testInd,])
print(summary(m0), printModels=FALSE)


###################################################
### chunk number 22: pimaB0
###################################################
#line 1047 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
b <- gamboost(as.factor(diabetes) ~ pregnant + glucose + pressure + mass + pedigree + age,
        family=Binomial(), data=pimaDiabTrain)[300]
aic <- AIC(b, method="classical")
prB <- predict(b[mstop(aic)], newdata=pimaDiab[testInd,])


###################################################
### chunk number 23: pimaB0Sum
###################################################
#line 1053 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
summary(b[mstop(aic)])$selprob


###################################################
### chunk number 24: pimaM0Pred
###################################################
#line 1057 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
dev <- function(y, p){
    -2*sum(dbinom(x=y, size=1, prob=p, log=T))
}
c(spikeSlabGAM=dev(pimaDiab[testInd,"diabetes"], pr0),
    gamboost=dev(pimaDiab[testInd,"diabetes"], plogis(prB)))


###################################################
### chunk number 25: pimaM1
###################################################
#line 1069 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
hyper1 <- list(gamma=c(v0=0.005))
m1 <- spikeSlabGAM(diabetes ~ pregnant + glucose + pressure + mass + pedigree + age,
        family="binomial", data=pimaDiabTrain, mcmc=mcmc, hyperparameters=hyper1)
pr1 <- predict(m1, newdata=pimaDiab[testInd,])


###################################################
### chunk number 26: pimaM1Sum
###################################################
#line 1074 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
print(summary(m1), printModels=FALSE)
(dev(pimaDiab[testInd,"diabetes"], pr1))


###################################################
### chunk number 27: sessionInfo
###################################################
#line 1098 "d:/Rcompile/CRANpkg/local/2.12/spikeSlabGAM/inst/doc/UsingSpikeSlabGAM.Rnw"
	sessionInfo()


